
{*************************************}
{                                     }
{         Mouse Unit 1.0              }
{         von Martin Hedler (1999)    }
{                                     }
{         Verbesserungen erwnscht    }
{*************************************}

unit mouse;

interface

uses crt, graph;

  var Cursor:Pointer;
      CursorVisible:boolean;

  const NO    = 0;
        RIGHT = 2;
        LEFT  = 1;

  procedure InitMouse;
  procedure ShowMouse;
  procedure HideMouse;
  function GetColumn:integer;
  function GetRow:integer;
  function GetTextColumn:integer;
  function GetTextRow:integer;
  function MouseButtonPressed:byte;
  procedure SetMouse(x,y:integer);
  procedure SetTextMouse(x,y:integer);
  function MouseIn(x1,y1,x2,y2:integer):boolean;
  function TextMouseIn(x1,y1,x2,y2:integer):boolean;
  procedure SetMouseArea(x1,y1,x2,y2:integer);
  procedure SetTextMouseArea(x1,y1,x2,y2:integer);
  procedure InitEventHandler(event:word;p:pointer);
  {Zusatzprozeduren}
  procedure UseOwnCursor;
  procedure ShowOwnCursor;
  procedure HideOwnCursor;

implementation

var mausbild:pointer;
    mousex,mousey:integer;

procedure initmouse; assembler;
asm
  xor ax,ax
  int 33h
end;

procedure showmouse; assembler;
asm
  mov ax,1
  int 33h
end;

procedure hidemouse; assembler;
asm
  mov ax,2
  int 33h
end;

function mousebuttonpressed:byte;
var k:integer;
begin
asm
  mov ax,3
  int 33h
  mov k,bx
end;
mousebuttonpressed:=k;
end;

function GetColumn:integer;
var k:integer;
begin
asm
  mov ax,3
  int 33h
  mov k,cx
end;
GetColumn:=k;
end;

function GetRow:integer;
var k:integer;
begin
asm
  mov ax,3
  int 33h
  mov k,dx
end;
GetRow:=k;
end;

function GetTextColumn:integer;
var k:integer;
begin
asm
  mov ax,3
  int 33h
  mov k,cx
end;
GetTextColumn:=k div 8 + 1;
end;

function GetTextRow:integer;
var k:integer;
begin
asm
  mov ax,3
  int 33h
  mov k,dx
end;
GetTextRow:=k div 8 + 1;
end;

procedure setmouse(x,y:integer); assembler;
asm
  mov cx,x
  mov dx,y
  mov ax,4
  int 33h
end;

procedure settextmouse(x,y:integer); assembler;
asm
  dec x
  dec y
  mov ax,8
  mul x
  mov cx,ax
  mov ax,8
  mul y
  mov dx,ax
  mov ax,4
  int 33h
end;

function MouseIn(x1,y1,x2,y2:integer):boolean;
var x,y:integer;
begin
  if x1>x2 then begin
                  x:=x1;
                  x1:=x2;
                  x2:=x;
                end;
  if y1>y2 then begin
                  y:=y1;
                  y1:=y2;
                  y2:=y;
                end;
  x:=getcolumn;
  y:=getrow;
  if (x>x1) and (x<x2) and (y>y1) and (y<y2) then MouseIn:=true;
end;

function TextMouseIn(x1,y1,x2,y2:integer):boolean;
var x,y:integer;
begin
  if x1>x2 then begin
                  x:=x1;
                  x1:=x2;
                  x2:=x;
                end;
  if y1>y2 then begin
                  y:=y1;
                  y1:=y2;
                  y2:=y;
                end;
  x:=gettextcolumn;
  y:=gettextrow;
  if (x>x1) and (x<x2) and (y>y1) and (y<y2) then TextMouseIn:=true;
end;

procedure initeventhandler(event:word;p:pointer);
type os = record
            o,s:word;
          end;
var o,s:word;
begin
  s:=os(p).s;
  o:=os(p).o;
  asm
    mov ax,s
    mov es,ax
    mov dx,o
    mov ax,000Ch
    mov cx,event
    int 33h
  end;
end;

procedure SetMouseArea(x1,y1,x2,y2:integer); assembler;
asm
  mov ax,7
  mov cx,x1
  mov dx,x2
  int 33h
  mov ax,8
  mov cx,y1
  mov dx,y2
  int 33h
end;

procedure SetTextMouseArea(x1,y1,x2,y2:integer); assembler;
asm
  mov ax,8
  mul x1
  mov cx,ax
  mov ax,8
  mul x2
  mov dx,ax
  mov ax,7
  int 33h
  mov ax,8
  mul y1
  mov cx,ax
  mov ax,8
  mul y2
  mov dx,ax
  mov ax,8
  int 33h
end;

{Zusatzprozeduren}

procedure stdCursor;
begin
  setcolor(15);
  line(mousex,mousey,mousex,mousey+10);
  line(mousex,mousey,mousex+9,mousey+5);
  line(mousex+9,mousey+5,mousex,mousey+10);
  line(mousex,mousey,mousex+12,mousey+20);
end;

procedure DrawCursor;
var TCursor:Procedure(a,b:integer);
    color:word;
begin
  if CursorVisible=true then begin
    putimage(mousex,mousey,mausbild^,NormalPut);
    mousex:=getcolumn;
    mousey:=getrow;
    getimage(mousex,mousey,mousex+20,mousey+20,mausbild^);
    color:=getcolor;
    if cursor<>nil then begin
                          @TCursor:=Cursor;
                          TCursor(mousex,mousey);
                        end;
    setcolor(color);
  end;
end;

procedure MouseMoved; interrupt;
begin
  DrawCursor;
end;

procedure UseOwnCursor;
begin
  cursor:=@stdCursor;
  setmousearea(0,0,getmaxx-20,getmaxy-20);
  setmouse(0,0);
  getmem(mausbild,404);
  getimage(mousex,mousey,mousex+20,mousey+20,mausbild^);
  ShowOwnCursor;
  initeventhandler(1,@mousemoved);
end;

procedure ShowOwnCursor;
begin
  Cursorvisible:=true;
end;

procedure HideOwnCursor;
begin
  Cursorvisible:=false;
{  putimage(mousex,mousey,mausbild^,NormalPut);}
end;

end.